<?php

/**
 *	Post-install script for geomap 2.0
 *	Takes old settings and merge it to new settings files
 */

define("FILE_LINKS", 'links.xml');
define("FILE_LOCATIONS", 'locations.xml');
define("FILE_VIEWPOINTS", 'viewpoints.xml');

//------------------------------------------------------------------------------

if (!isset($argv[1])) {
	define("DIR_OLD_SETTINGS", '/opt/monitor/op5/nagvis/etc/geomap/');
	define("DIR_SETTINGS", '/opt/monitor/op5/ninja/application/config/geomap/');
	echo "use default destination to geomap settings files:\n" . DIR_OLD_SETTINGS . " and " . DIR_SETTINGS . "\n";
}
else
{
	if (!isset($argv[2])) {
		exit("Warning: No geomap settings destination. Exit from update_geomap_settings.php.\n");
	}
	check($argv[1]);
	check($argv[2]);

	define("DIR_OLD_SETTINGS", $argv[1]);
	define("DIR_SETTINGS", $argv[2]);
}

//------------------------------------------------------------------------------

function merge_files( $file )
{
	if (file_exists(DIR_OLD_SETTINGS . $file) === FALSE) {
		return TRUE;
	}

	if (($old = @ simplexml_load_file(DIR_OLD_SETTINGS . $file)) === FALSE) {
		print "Warring: Failed to parse old geomap settings:" . DIR_OLD_SETTINGS.$file . "\n";
		return TRUE;
	}

	if (file_exists(DIR_SETTINGS . $file) === FALSE) {
		print "Warring: Missing geomap settings file:" . DIR_SETTINGS.$file . "\n";
		return TRUE;
	}

	if (($xml = @ simplexml_load_file(DIR_SETTINGS . $file)) === FALSE) {
		print "Warring: Geomap settings seem corrupt:" . DIR_SETTINGS.$file . "\n";
		return TRUE;
	}

	append_to_xml($xml, $old);
	if (file_put_contents(DIR_SETTINGS . $file, $xml->asXml()) === FALSE) {
		print "Error: Unable to update geomap settings:" . DIR_SETTINGS.$file . "\n";
		return TRUE;
	}
	return TRUE;
}


function check(&$str)
{
	if ($str[strlen($str)-1] != '/')
		$str .= '/';
}

function append_to_xml(&$xml_to, &$xml_from)
{
	foreach ($xml_from->children() as $xml_child) {
		$xml_temp = $xml_to->addChild($xml_child->getName(), (string) $xml_child);

		foreach ($xml_child->attributes() as $key => $value) {
			$xml_temp->addAttribute($key, $value);
		}
	append_to_xml($xml_temp, $xml_child);
	}
}

?>
